/* DBHelper.h - NeonServ v5.5
 * Copyright (C) 2011-2012  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */
#ifndef _DBHelper_h
#define _DBHelper_h

#include "main.h"
struct UserNode;
struct ChanNode;

#define DB_CHANUSER_SUSPENDED 0x01
#define DB_CHANUSER_AUTOINVITE 0x02
#define DB_CHANUSER_NOAUTOOP 0x04

#define loadUserSettings(USER) if((USER->flags & USERFLAG_ISAUTHED) && !(USER->flags & USERFLAG_LOADED_SETTINGS)) _loadUserSettings(USER)
#define loadChannelSettings(CHAN) if(!(CHAN->flags & CHANFLAG_REQUESTED_CHANINFO)) _loadChannelSettings(CHAN)

#ifndef DND_FUNCTIONS
/* MODULAR ACCESSIBLE */ void _loadUserSettings(struct UserNode* user);
/* MODULAR ACCESSIBLE */ int isGodMode(struct UserNode *user);
/* MODULAR ACCESSIBLE */ char *getChanDefault(char *channel_setting);
/* MODULAR ACCESSIBLE */ int getChannelAccess(struct UserNode *user, struct ChanNode *chan);
/* MODULAR ACCESSIBLE */ int checkChannelAccess(struct UserNode *user, struct ChanNode *chan, char *channel_setting, int allow_501);
/* MODULAR ACCESSIBLE */ void _loadChannelSettings(struct ChanNode *chan);

/* MODULAR ACCESSIBLE */ int isUserProtected(struct ChanNode *chan, struct UserNode *victim, struct UserNode *issuer);

/* MODULAR ACCESSIBLE */ char *getBanAffectingMask(struct ChanNode *chan, char *mask); //returns bans that match a given mask   eg. *!*@ab*  if you pass  *!*@abcdefg.*

/* MODULAR ACCESSIBLE */ int renameAccount(char *oldauth, char *newauth);

/* MODULAR ACCESSIBLE */ void deleteUser(int userid);

void init_DBHelper();
#endif
#endif
