/* lang.h - NeonServ v5.5
 * Copyright (C) 2011-2012  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */
#ifndef _lang_h
#define _lang_h

#include "main.h"

struct UserNode;

struct default_language_entry {
    char *ident;
    char *text;
};

struct language_table {
    char *ident;
    char *text;
    
    struct language_table *next;
};

struct language {
    char *langtag;
    char *langname;
    struct language_table **entrys;
};

#ifndef DND_FUNCTIONS
void init_lang();
void free_lang();
/* MODULAR ACCESSIBLE */ struct language* get_language_by_tag(char *tag);
/* MODULAR ACCESSIBLE */ struct language* get_language_by_name(char *name);
/* MODULAR ACCESSIBLE */ struct language* get_default_language();
void load_languages();
/* MODULAR ACCESSIBLE */ void load_language(char *tag, char *name);
void register_language_string(struct language *lang, char *ident, char *text);
/* MODULAR ACCESSIBLE */ void register_default_language_table(const struct default_language_entry *msgtab);
/* MODULAR ACCESSIBLE */ char *get_language_string(struct UserNode *user, const char* msg_ident);
/* MODULAR ACCESSIBLE */ char *build_language_string(struct UserNode *user, char *buffer, const char *msg_ident, ...);
#endif
#endif
