/* main.h - NeonServ v5.5
 * Copyright (C) 2011-2012  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */
#ifndef _main_h
#define _main_h
#include "overall.h"

#ifndef DND_FUNCTIONS
extern time_t start_time;
extern int statistics_enabled;
#ifdef HAVE_THREADS
extern int running_threads;
extern pthread_mutex_t cache_sync;
extern pthread_mutex_t whohandler_sync, whohandler_mass_sync;

/* MODULAR ACCESSIBLE */ int getCurrentThreadID();
#endif

/* MODULAR ACCESSIBLE */ time_t getStartTime();
/* MODULAR ACCESSIBLE */ int getRunningThreads();

void exit_daemon();

/* MODULAR ACCESSIBLE */ int stricmp (const char *s1, const char *s2);
/* MODULAR ACCESSIBLE */ int stricmplen (const char *s1, const char *s2, int len);

/* MODULAR ACCESSIBLE */ void restart_process();
/* MODULAR ACCESSIBLE */ void cleanup();
/* MODULAR ACCESSIBLE */ void restart_bot(int do_hard_restart);
/* MODULAR ACCESSIBLE */ void stop_bot();
/* MODULAR ACCESSIBLE */ void reload_config();

int statistics_update();

/* MODULAR ACCESSIBLE */ void putlog(int loglevel, const char *text, ...) PRINTF_LIKE(2, 3);
#endif
#endif