/* memoryInfo.h - NeonServ v5.5
 * Copyright (C) 2011-2012  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */
#ifndef _memoryinfo_h
#define _memoryinfo_h

struct memoryInfoFiles {
    char *filename;
    unsigned int allocations;
    unsigned int allocated;
    struct memoryInfoFiles *next;
};

#ifndef DND_FUNCTIONS
/* MODULAR ACCESSIBLE */ struct memoryInfoFiles *getMemoryInfoFiles();
/* MODULAR ACCESSIBLE */ void freeMemoryInfoFiles(struct memoryInfoFiles *files);
#endif

struct memoryInfoLines {
    unsigned int line;
    unsigned int allocations;
    unsigned int allocate;
    struct memoryInfoLines *next;
};

#ifndef DND_FUNCTIONS
/* MODULAR ACCESSIBLE */ struct memoryInfoLines *getMemoryInfoLines(const char *filename);
/* MODULAR ACCESSIBLE */ void freeMemoryInfoLines(struct memoryInfoLines *lines);
#endif

#endif
