/* modules.h - NeonServ v5.5
 * Copyright (C) 2011-2012  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */
#ifndef _modules_h
#define _modules_h
#include "main.h"

#define MODINFO_STATE_STARTED   0x01
#define MODINFO_STATE_PROTECTED 0x02

struct ModuleInfo {
    char *name;
    int module_id;
    #ifndef WIN32
    void *module;
    #else
    HMODULE module;
    #endif
    int state;
    void *startfunc;
    void *stopfunc;
    struct ModuleInfo *next;
};

#ifndef DND_FUNCTIONS
void loadModules();
struct ModuleInfo *loadModule(char *name);
void start_modules();
void stop_modules();
int module_loaded(int module_id);

/* MODULAR ACCESSIBLE */ char *get_module_name(int module_id);

int ext_load_module(char *name);
int ext_unload_module(char *name);
int ext_reload_module(char *name);
struct ModuleInfo *ext_get_modules(struct ModuleInfo *last);
#endif
#endif
