/* cmd_neonfun_unotake.c - NeonServ v5.5
 * Copyright (C) 2011-2012  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */

#include "cmd_neonfun.h"
#include "game_uno.h"

CMD_BIND(neonfun_cmd_unotake) {
    struct ChanUser *chanuser = getChanUser(user, chan);
    if(!chanuser) return;
    struct uno_game *game;
    for(game = uno_active_games; game; game = game->next) {
        if(chan == game->channel) {
            if(game->state == UNO_STATE_WAITING)
                return;
            else 
                break;
        }
    }
    if(game) {
        //check if it's the player's turn
        if(game->active_player->chanuser != chanuser) {
            reply(textclient, user, "NF_UNO_NOT_YOUR_TURN");
            return;
        }
        game->active_player->timeout = 0;
        uno_action_take_card(game, game->active_player);
    }
}
