/* bot_NeonHelp.h - NeonServ v5.5
 * Copyright (C) 2011-2012  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */
#ifndef _bot_NeonHelp_h
#define _bot_NeonHelp_h

#include "../../main.h"

/* definition for ClientSocket struct */
#define botclass_helpnode botclassvalue1 
#define SOCKET_HAVE_HELPNODE SOCKET_HAVE_BOTCLASSVALUE1

#define LOGBUFFERLINES 20

struct UserNode;
struct ChanNode;
struct ClientSocket;

struct NeonHelpNode {
    struct UserNode *user;
    int suppid;
    char status:6;
    char announce:2;
    struct NeonHelpNode *next;
    struct ChanNode *logchan;
    char **log;
};

void init_NeonHelp(int type);
void free_NeonHelp(int type);

void neonhelp_destroy_support_request(struct ClientSocket *client, struct NeonHelpNode *helpnode, int do_reply);
void neonhelp_invite_active_requests(struct ClientSocket *client, struct ChanNode *support, struct ChanNode *public, struct UserNode *ignore_user);

#endif