/* cmd_neonhelp_stats.c - NeonServ v5.5
 * Copyright (C) 2011-2012  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */

#include "cmd_neonhelp.h"

/*
* argv[0]   user
*/

CMD_BIND(neonhelp_cmd_stats) {
    //check permissions
    MYSQL_RES *res;
    MYSQL_ROW row, row2;
    int caccess = 0;
    printf_mysql_query("SELECT `helpserv_support`, `helpserv_public`, `helpserv_intern` FROM `helpserv_settings` WHERE `helpserv_botid` = '%d'", client->clientid);
    res = mysql_use();
    if (!(row = mysql_fetch_row(res))) return;
    //check if the user is a supporter (access in the support channel)
    if((user->flags & USERFLAG_ISAUTHED)) {
        int userid;
        if(user->flags & USERFLAG_HAS_USERID)
            userid = user->user_id;
        else {
            printf_mysql_query("SELECT `user_id` FROM `users` WHERE `user_user` = '%s'", escape_string(user->auth));
            res = mysql_use();
            if ((row2 = mysql_fetch_row(res)) != NULL) {
                userid = atoi(row2[0]);
                user->user_id = userid;
                user->flags |= USERFLAG_HAS_USERID;
            } else
                userid = 0;
        }
        printf_mysql_query("SELECT `chanuser_access`, `chanuser_flags` FROM `chanusers` LEFT JOIN `channels` ON `chanuser_cid` = `channel_id` WHERE `chanuser_uid` = '%d' AND `channel_name` = '%s'", userid, escape_string(row[0]));
        res = mysql_use();
        if ((row2 = mysql_fetch_row(res)) != NULL) {
            int cflags = atoi(row2[1]);
            if(!(cflags & DB_CHANUSER_SUSPENDED))
                caccess = atoi(row2[0]);
        }
    }
    if(!caccess) {
        reply(textclient, user, "MODCMD_ACCESS_DENIED");
        return;
    }
    if(argc > 0) {
        //following
    } else {
        struct Table *table;
        printf_mysql_query("SELECT DISTINCT a.`supporter`, `user_user`, (SELECT COUNT(*) FROM `helpserv_requests` AS b WHERE b.`supporter` = a.`supporter` AND b.`time` > (UNIX_TIMESTAMP()-(3600*24))), (SELECT COUNT(*) FROM `helpserv_requests` AS b WHERE b.`supporter` = a.`supporter` AND b.`time` > (UNIX_TIMESTAMP()-(3600*24*7))), (SELECT COUNT(*) FROM `helpserv_requests` AS b WHERE b.`supporter` = a.`supporter` AND b.`time` > (UNIX_TIMESTAMP()-(3600*24*7*4))) FROM `helpserv_requests` AS a LEFT JOIN `users` ON a.`supporter` = `user_id` WHERE a.`time` > (UNIX_TIMESTAMP()-(3600*24*7*4))  AND `botid` = '%d' ORDER BY `user_user` ASC", client->clientid);
        res = mysql_use();
        table = table_init(4, mysql_num_rows(res) + 1, 0);
        char *content[4];
        content[0] = get_language_string(user, "NH_STATS_HEADER_USER");
        content[1] = get_language_string(user, "NH_STATS_HEADER_LAST_24H");
        content[2] = get_language_string(user, "NH_STATS_HEADER_LAST_7DAY");
        content[3] = get_language_string(user, "NH_STATS_HEADER_LAST_30DAY");
        table_add(table, content);
        while ((row = mysql_fetch_row(res)) != NULL) {
            content[0] = (strcmp(row[0], "-1") ? row[1] : "-");
            content[1] = row[2];
            content[2] = row[3];
            content[3] = row[4];
            table_add(table, content);
        }
        char **table_lines = table_end(table);
        int i;
        for(i = 0; i < table->entrys; i++) {
            reply(textclient, user, table_lines[i]);
        }
        if(table->entrys == 1)
            reply(textclient, user, "NS_TABLE_NONE");
        table_free(table);
    }
}
