/* cmd_neonserv_delban.c - NeonServ v5.5
 * Copyright (C) 2011-2012  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */

#include "cmd_neonserv.h"

/*
* argv[0]    nick|*auth|*!*@mask
*/

CMD_BIND(neonserv_cmd_delban) {
    char hostmask_buffer[NICKLEN+USERLEN+HOSTLEN+3];
    char *mask = make_banmask(argv[0], hostmask_buffer);
    int matching_bans = 0;
    MYSQL_RES *res;
    MYSQL_ROW row;
    //check if the provided mask affects any existing bans
    char nameBuf[20];
    printf_mysql_query("SELECT `ban_mask`, `ban_id`, `ban_timeout` FROM `bans` WHERE `ban_channel` = '%d'", chan->channel_id);
    res = mysql_use();
    while ((row = mysql_fetch_row(res)) != NULL) {
        if(!match(mask, row[0])) {
            //remove the ban
            if(strcmp(row[2], "0")) {
                sprintf(nameBuf, "ban_%s", row[1]);
                timeq_del_name(nameBuf);
            }
            printf_mysql_query("DELETE FROM `bans` WHERE `ban_id` = '%s'", row[1]);
            matching_bans++;
        }
    }
    if(matching_bans) {
        putsock(client, "MODE %s -b %s", chan->name, mask);
        reply(textclient, user, "NS_DELBAN_DONE", mask, chan->name);
        logEvent(event);
    } else
        reply(textclient, user, "NS_DELBAN_FAIL", mask);
}
