/* cmd_neonserv_devoice.c - NeonServ v5.5
 * Copyright (C) 2011-2012  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */

#include "cmd_neonserv.h"

/*
* argv[0-*]    nicks
*/

CMD_BIND(neonserv_cmd_devoice) {
    int i, done_users = 0;
    struct UserNode *cuser;
    struct ChanUser *chanuser;
    struct ModeBuffer *modeBuf;
    modeBuf = initModeBuffer(client, chan);
    for(i = 0; i < argc; i++) {
        cuser = searchUserByNick(argv[i]);
        if(!cuser) continue;
        chanuser = getChanUser(cuser, chan);
        if(!chanuser) continue;
        if(isUserProtected(chan, cuser, user)) {
            reply(textclient, user, "NS_USER_PROTECTED", cuser->nick);
            continue;
        }
        done_users++;
        if(!(chanuser->flags & CHANUSERFLAG_VOICED)) continue;
        modeBufferDevoice(modeBuf, argv[i]);
    }
    freeModeBuffer(modeBuf);
    if(done_users == argc)
        reply(textclient, user, "NS_DEVOICE_DONE", chan->name);
    else
        reply(textclient, user, "NS_DEVOICE_FAIL", client->user->nick);
    if(done_users)
        logEvent(event);
}
