/* cmd_neonserv_listrank.c - NeonServ v5.5
 * Copyright (C) 2011-2012  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */

#include "cmd_neonserv.h"

/*
* no arguments
*/

CMD_BIND(neonserv_cmd_listrank) {
    MYSQL_RES *res, *res2;
    MYSQL_ROW row, row2;
    struct Table *table;
    int ranks = 0;
    printf_mysql_query("SELECT `rank_id`, `rank_name` FROM `support_ranks` ORDER BY `rank_order` ASC");
    res = mysql_use();
    table = table_init(3, mysql_num_rows(res) + 1, 0);
    char *content[3];
    content[0] = get_language_string(user, "NS_LISTRANK_ID");
    content[1] = get_language_string(user, "NS_LISTRANK_NAME");
    content[2] = get_language_string(user, "NS_LISTRANK_ASSIGNED");
    table_add(table, content);
    char usersBuf[MAXLEN];
    int usersPos, userCount;
    char assignedBuf[MAXLEN];
    while ((row = mysql_fetch_row(res)) != NULL) {
        ranks++;
        content[0] = row[0];
        content[1] = row[1];
        printf_mysql_query("SELECT `user_user`, `user_god` FROM `users` WHERE `user_rank` = '%s'", row[0]);
        res2 = mysql_use();
        usersPos = 0;
        userCount = 0;
        while((row2 = mysql_fetch_row(res2)) != NULL) {
            usersPos += sprintf(usersBuf+usersPos, (usersPos ? ", %s%s" : "%s%s"), (strcmp(row2[1], "0") ? "@" : ""), row2[0]);
            userCount++;
        }
        sprintf(assignedBuf, (userCount ? "%d (%s)" : "%d"), userCount, usersBuf);
        content[2] = assignedBuf;
        table_add(table, content);
    }
    //send the table
    char **table_lines = table_end(table);
    int i;
    for(i = 0; i < table->entrys; i++) {
        reply(textclient, user, table_lines[i]);
    }
    if(!ranks)
        reply(textclient, user, "NS_TABLE_NONE");
    table_free(table);
    printf_mysql_query("SELECT `user_user` FROM `users` WHERE `user_rank` = '0' AND `user_access` > 0");
    res2 = mysql_use();
    usersPos = 0;
    userCount = 0;
    while((row2 = mysql_fetch_row(res2)) != NULL) {
        usersPos += sprintf(usersBuf+usersPos, (usersPos ? ", %s%s" : "%s%s"), (strcmp(row2[1], "0") ? "@" : ""), row2[0]);
        userCount++;
    }
    reply(textclient, user, "NS_LISTRANK_UNRANKED", userCount);
    if(userCount) {
        reply(textclient, user, "  %s", usersBuf);
    }
}
