/* cmd_neonserv_recover.c - NeonServ v5.5
 * Copyright (C) 2011-2012  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */

#include "cmd_neonserv.h"

/*
* argv[0] - channel
*/
CMD_BIND(neonserv_cmd_recover) {
    MYSQL_RES *res;
    MYSQL_ROW row, row2;
    char *channel = argv[0];
    if(!is_valid_chan(channel)) {
        reply(textclient, user, "NS_INVALID_CHANNEL_NAME", argv[0]);
        return;
    }
    int chanid;
    printf_mysql_query("SELECT `channel_id` FROM `channels` WHERE `channel_name` = '%s'", escape_string(channel));
    res = mysql_use();
    if ((row = mysql_fetch_row(res)) != NULL) {
        chanid = atoi(row[0]);
    } else {
        reply(textclient, user, "NS_UNREGISTER_NOT_REGISTERED", argv[0], client->user->nick);
        return;
    }
    printf_mysql_query("SELECT `botid`, `bot_channels`.`id` FROM `bot_channels` LEFT JOIN `bots` ON `bot_channels`.`botid` = `bots`.`id` WHERE `chanid` = '%d' AND `botclass` = '%d'", chanid, client->botid);
    res = mysql_use();
    if ((row = mysql_fetch_row(res)) != NULL) {
        reply(textclient, user, "NS_REGISTER_ALREADY", argv[0], client->user->nick);
        return;
    }
    printf_mysql_query("SELECT `id`, `max_channels`, `defaulttrigger` FROM `bots` WHERE `botclass` = '%d' ORDER BY `register_priority` DESC", client->botid);
    res = mysql_use();
    int botid = 0;
    char *bottrigger;
    while ((row = mysql_fetch_row(res)) != NULL) {
        //check channel count
        printf_mysql_query("SELECT COUNT(*) FROM `bot_channels` WHERE `botid` = '%s'", row[0]);
        row2 = mysql_fetch_row(mysql_use());
        if(atoi(row2[0]) < atoi(row[1])) {
            botid = atoi(row[0]);
            bottrigger = row[2];
            break;
        }
    }
    if(!botid) {
        reply(textclient, user, "NS_REGISTER_FULL");
        return;
    }
    struct ClientSocket *bot;
    for(bot = getBots(SOCKET_FLAG_READY, NULL); bot; bot = getBots(SOCKET_FLAG_READY, bot)) {
        if(bot->clientid == botid)
            break;
    }
    if(bot) {
        putsock(bot, "JOIN %s", channel);
    } else
        reply(textclient, user, "NS_REGISTER_DISCONNECTED");
    printf_mysql_query("INSERT INTO `bot_channels` (`botid`, `chanid`, `trigger`) VALUES ('%d', '%d', '%s')", botid, chanid, bottrigger);
    reply(textclient, user, "NS_RECOVER_DONE", channel);
    logEvent(event);
}
