/* cmd_global_bots.c - NeonServ v5.5
 * Copyright (C) 2011-2012  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */

#include "cmd_global.h"

/*
* argv[0]    (optional) class name
*/

CMD_BIND(global_cmd_bots) {
    struct Table *table;
    MYSQL_RES *res, *res2;
    MYSQL_ROW row, row2;
    printf_mysql_query("SELECT `active`, `nick`, `server`, `port`, `pass`, `botclass`, `textbot`, `queue`, `defaulttrigger`, `max_channels`, `register_priority`, `id`, `secret` FROM `bots`");
    res = mysql_use();
    table = table_init(7, mysql_num_rows(res) + 1, 0);
    char *content[7];
    content[0] = get_language_string(user, "NS_BOTS_ID");
    content[1] = get_language_string(user, "NS_BOTS_NICK");
    content[2] = get_language_string(user, "NS_BOTS_SERVER");
    content[3] = get_language_string(user, "NS_BOTS_CLASS");
    content[4] = get_language_string(user, "NS_BOTS_FLAGS");
    content[5] = get_language_string(user, "NS_BOTS_CHANNELS");
    content[6] = get_language_string(user, "NS_BOTS_TRIGGER");
    table_add(table, content);
    char botnick[NICKLEN + 3];
    char botserver[MAXLEN];
    char botflags[10];
    int flagspos;
    char botchans[20];
    while ((row = mysql_fetch_row(res)) != NULL) {
        content[0] = row[11];
        sprintf(botnick, (strcmp(row[0], "0") ? "%s" : "!%s"), row[1]);
        content[1] = botnick;
        sprintf(botserver, (strcmp(row[4], "") ? "%s:%s:*" : "%s:%s"), row[2], row[3]);
        content[2] = botserver;
        content[3] = (char *) resolve_botid(atoi(row[5]));
        flagspos = 0;
        if(!strcmp(row[6], "1"))
            botflags[flagspos++] = 't';
        if(!strcmp(row[7], "1"))
            botflags[flagspos++] = 'q';
        if(!strcmp(row[12], "1"))
            botflags[flagspos++] = 's';
        botflags[flagspos] = '\0';
        content[4] = botflags;
        printf_mysql_query("SELECT COUNT(*) FROM `bot_channels` WHERE `botid` = '%s'", row[11]);
        res2 = mysql_use();
        row2 = mysql_fetch_row(res2);
        sprintf(botchans, "%s/%s", row2[0], row[9]);
        content[5] = botchans;
        content[6] = row[8];
        table_add(table, content);
    }
    char **table_lines = table_end(table);
    int i;
    for(i = 0; i < table->entrys; i++) {
        reply(textclient, user, table_lines[i]);
    }
    table_free(table);
}