/* cmd_global_god.c - NeonServ v5.5
 * Copyright (C) 2011-2012  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */

#include "cmd_global.h"

/*
* argv[0]    (optional) on/off
*/

CMD_BIND(global_cmd_god) {
    if(argc > 0) {
        if(!strcmp(argv[0], "0") || !stricmp(argv[0], "off") || !stricmp(argv[0], get_language_string(user, "NS_SET_OFF"))) {
            if(isGodMode(user)) {
                printf_mysql_query("UPDATE `users` SET `user_god` = '0' WHERE `user_user` = '%s'", escape_string(user->auth));
                user->flags &= ~USERFLAG_GOD_MODE;
            }
            reply(textclient, user, "NS_GOD_OFF");
        } else if(!strcmp(argv[0], "1") || !stricmp(argv[0], "on") || !stricmp(argv[0], get_language_string(user, "NS_SET_ON"))) {
            if(!isGodMode(user)) {
                printf_mysql_query("UPDATE `users` SET `user_god` = '1' WHERE `user_user` = '%s'", escape_string(user->auth));
                user->flags |= USERFLAG_GOD_MODE;
            }
            reply(textclient, user, "NS_GOD_ON");
        } else {
            reply(textclient, user, "NS_SET_INVALID_BOOLEAN", argv[0]);
            return;
        }
    } else {
        if(isGodMode(user)) {
            printf_mysql_query("UPDATE `users` SET `user_god` = '0' WHERE `user_user` = '%s'", escape_string(user->auth));
            user->flags &= ~USERFLAG_GOD_MODE;
            reply(textclient, user, "NS_GOD_OFF");
        } else {
            printf_mysql_query("UPDATE `users` SET `user_god` = '1' WHERE `user_user` = '%s'", escape_string(user->auth));
            user->flags |= USERFLAG_GOD_MODE;
            reply(textclient, user, "NS_GOD_ON");
        }
    }
}