/* mysqlConn.h - NeonServ v5.5
 * Copyright (C) 2011-2012  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */
#ifndef _MySQLConn_h
#define _MySQLConn_h

#include "main.h"
#include <mysql.h>
#include <mysql/errmsg.h>

#define MYSQLMAXLEN 1024

#ifndef DND_FUNCTIONS
/* MODULAR ACCESSIBLE */ MYSQL_RES *mysql_use();
/* MODULAR ACCESSIBLE */ void mysql_free();
void init_mysql(char *host, int port, char *user, char *pass, char *base);
void free_mysql();
/* MODULAR ACCESSIBLE */ void printf_mysql_query(const char *text, ...) PRINTF_LIKE(1, 2);
/* MODULAR ACCESSIBLE */ void printf_long_mysql_query(int len, const char *text, ...) PRINTF_LIKE(2, 3);
/* MODULAR ACCESSIBLE */ char* escape_string(const char *str);
/* MODULAR ACCESSIBLE */ MYSQL *get_mysql_conn();
#endif
#endif
