/* timeq.h - NeonServ v5.5
 * Copyright (C) 2011-2012  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */
#ifndef _timeq_h
#define _timeq_h

#include "main.h"

#define TIMEQ_CALLBACK(NAME) void NAME(UNUSED_ARG(void *data))
typedef TIMEQ_CALLBACK(timeq_callback_t);

struct IODescriptor;

struct timeq_entry {
    struct IODescriptor *iofd;
    char *name;
    int module_id;
    timeq_callback_t *callback;
    void *data;
    
    struct timeq_entry *prev, *next;
};

#ifndef DND_FUNCTIONS
/* MODULAR ACCESSIBLE */ struct timeq_entry* timeq_add(int seconds, int module_id, timeq_callback_t *callback, void *data);
/* MODULAR ACCESSIBLE */ struct timeq_entry* timeq_uadd(int useconds, int module_id, timeq_callback_t *callback, void *data);
/* MODULAR ACCESSIBLE */ struct timeq_entry* timeq_add_name(char *name, int seconds, int module_id, timeq_callback_t *callback, void *data);
/* MODULAR ACCESSIBLE */ struct timeq_entry* timeq_uadd_name(char *name, int useconds, int module_id, timeq_callback_t *callback, void *data);
/* MODULAR ACCESSIBLE */ int timeq_del(struct timeq_entry* entry);
/* MODULAR ACCESSIBLE */ int timeq_del_name(char *name);
/* MODULAR ACCESSIBLE */ int timeq_name_exists(char *name);
void unregister_module_timers(int module_id);
#endif
#endif
